
displaymutatedARG <- function(b,interactive=TRUE,small=FALSE,highlight)
  {
    
    plotshared <- function(m,currorder,pos) {
      par(mar=c(0,0,0,0))
      y <- 1:b$ss
      mo <- m[currorder,]
      plot(-100,-100,ylim=c(1,b$ss),xlim=c(1,b$sites),axes=F,ylab="",xlab="")
      segments(mo[,1],y,mo[,2],y,col="blue",lwd=2)
      segments(1,1,1,b$ss,col="lightblue");
      segments(b$sites,1,b$sites,b$ss,col="lightblue");
      segments(pos,1,pos,b$ss,col="salmon");
    }
    l <- treelength(b);
    h <- treeheight(b)
    plotlen <- function(pos)
      {
        screen(5,TRUE)
        par(mar=c(0,2,0,0))
        plot(1:b$sites,h,type="l",lwd=2,axes=F)
        segments(pos,0,pos,10,col="salmon");
          axis(2)
        screen(6,TRUE)
        par(mar=c(0,2,0,0))
        plot(1:b$sites,l,type="l",lwd=2,axes=F)
        segments(pos,0,pos,30,col="salmon");
        axis(2)
        rug(b$positions,lwd=2);
      }
    
    treeplot <- function(m) {
      
      usepos <- round(v$x,0)
      if (!small) {
        if (usepos<1||usepos>b$var)
          usepos <- -1
        else 
          usepos <- b$positions[usepos]
      }
      if (usepos<1||usepos>b$sites)
        cat("this position outside region, try again")
      else {
        screen(3,new=T); 
        par(mar=c(0,0,0,0))
        tp <- tree(b,usepos);
        currentorder <- as.numeric(tp$tip.label)+1
        plot(tp,edge.width=2,bg="white",x.lim=th)
        plotlen(usepos);
       # screen(4,new=T);
        m <- sharedsection(b,usepos);
     #   plotshared(m,currentorder,usepos);
        
        screen(2,TRUE)
        genoplot(currentorder,m)
      }
    }
    
    genoplot <- function(currorder,m) {
      if (small) {
        plot(-100,-1,ylim=c(1,(b$ss)),xlim=c(1,b$sites),axes=F,xlab="",ylab="",xaxs="i")
        abline(h=1:b$ss,col="lightcyan",lwd=4)
        abline(v=b$positions,col="lightcyan",lwd=1)
        y <- matrix((1:b$ss),nrow=b$ss,ncol=length(b$position))[b$d==1]
        x <- matrix(b$position,nrow=b$ss,ncol=length(b$position),byrow=T)[b$d==1]
        if (!missing(highlight)) {
          col1 <-  matrix(highlight,nrow=b$ss,ncol=length(b$position),byrow=T)
          col2 <- matrix("black",nrow=b$ss,ncol=length(b$position))
          col2[col1] <- "red"
          col2 <- col2[b$d==1]
        } else col2 <- "black"
        points(x,y,pch=16,cex=0.3,col=col2)
      } else {
       
        posmat <- matrix(b$position,nrow=nrow(b$d),ncol=ncol(b$d),byrow=T)
        mod <- posmat>m[currorder,1]&posmat<m[currorder,2]
       # print(mod)
         dat <- b$d[currorder,] + mod*0.1;
        d <- t(dat)
        
        image(y=1:b$ss,x=1:b$var,d,axes=F,xlab="",ylab="",col=c("white","cyan","black"),breaks=c(-1,0.05,0.15,1.15))
                                        #image(t(b$d),ylim=c(1,(b$ss)),xlim=c(1,b$sites),axes=F,xlab="",ylab="")
      }
                                        # text(-3,1:b$ss,(0:(b$ss-1)),cex=1.5)
      axis(2,at=1:(b$ss),labels=currorder-1,tick=F,lwd=0,las=1,cex.lab=1.2)
    }
    
    
    if (interactive) {
      split.screen(c(2,1));
      split.screen(c(1,2),screen=1)
      split.screen(c(2,1),screen=4)
      screen(2);
    }
    th <- max(treeheight(b))*1.1;
    opar <- par(mar=c(0,2,0,0),bg="white");
    m <- sharedsection(b,10)
    genoplot(1:b$ss,m);
    
    if (interactive) {
      while(TRUE) {
        v <- locator(1);
        #print(v)
       # if (!small)  v <- list(x=v$y,y=v$x)
        if (v$y>b$ss) break
        treeplot(v);
        
      }
    }
    
    par(opar)
  }
